OBJ
  fat: "SD2.0_FATEngine"
  dac: "PCM2.1_DACEngine"

CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  leftPinNumber = 6
  rightPinNumber = 8

  dataOutPin = 0
  clockPin = 1   
  dataInPin = 2  
  chipSelectPin =3

  RTCDATpin = 29
  RTCCLKpin = 28

PUB Go
 
  dira[6]~~
  dira[8]~~
  repeat
     playWAV(string("Music.wav"))
  
PRI playWAV(fileName)

  if(playerID)
    cogstop(-1 + playerID~)
 
  playerDoneFlag := false
  playerID := (cognew(WAVPlayer(fileName), @WAVStack) + 1)
 
PRI WAVPlayer(fileName)
  
  fat.mountPartition(0, 0)
  fat.openFile(fileName, 0)
 
  fat.changeFilePosition(22)                         
  dac.numberOfChannelsSetup(fat.readShort)
 
  dac.sampleRateSetup(playerSpeed := fat.readLong)
 
  fat.changeFilePosition(34)
  result := fat.readShort
 
  dac.bitsPerSampleSetup(result)
  dac.sampleSignSetup(result == 16)
 
  fat.changeFilePosition(40)
 
  dac.startPlayer
  repeat (fat.readLong >> 9)
    fat.readData(dac.transferData, 512)
 
  dac.clearData
  dac.stopPlayer
 
  fat.unmountPartition
  playerDoneFlag := true
  cogstop(cogid)                


DAT WAVDat

playerSpeed        long 0
playerID               byte 0
playerDoneFlag     byte 0
WAVStack           long 0[100]